#include <w3c-libwww/WWWLib.h>
#include <w3c-libwww/WWWInit.h>
#include <w3c-libwww/WWWHTML.h>
#include <getopt.h>
#include "qclear.h"

/* mailman  list member only mode ϶, ׿ִ spam  ִ α׷ .*/

int last_number = 0;
HTAssocList * formfields = NULL;
int verbose_mode = FALSE;


PRIVATE int printer (const char * fmt, va_list pArgs)
{
    int ret = TRUE;
    if ( verbose_mode )
	ret = vfprintf(stdout, fmt, pArgs);
    return ret ;
}

PRIVATE int tracer (const char * fmt, va_list pArgs)
{
    int ret = TRUE;
    if ( verbose_mode )
	ret = vfprintf(stdout, fmt, pArgs);
    return ret ;
}

PRIVATE int terminate_handler (HTRequest * request, HTResponse * response,
			       void * param, int status) 
{
    
    HTEventList_stopLoop ();

    return HT_OK; /* stop */
}


PRIVATE void GetNumber (HText * text, int element_number, const BOOL * present, const char **	value)
{
    SGML_dtd * dtd = HTML_dtd();
    HTTag * tag = SGML_findTag(dtd, element_number);

    if (tag) {
	int n = 0;
	int check = 0;
	char * tagname = HTTag_name(tag);
	int maxcnt = HTTag_attributes(tag);
	int cnt;
	/* input tag  , type  radio ΰ . */
	if ( tagname && strcmp ( tagname , "INPUT" ) == 0 )
	{
	    for (cnt=0; cnt<maxcnt; cnt++) {
		if (present[cnt]) {
		    char * attrname = HTTag_attributeName(tag, cnt);
		    if ( attrname && (strcmp ( attrname , "NAME" ) == 0 ) )
		    {
			n = strtol ( value[cnt] , NULL , 10 );
			check = 1;
		    }
		    if ( check && ( strcmp ( attrname , "TYPE" ) == 0 ) )
		    {
			if ( strcmp ( value[cnt] , "RADIO" ) == 0 && last_number != n )
			{
			    
			    char string[100];
			    
			    memset ( string , 0 , sizeof ( string ) );
			    last_number = n;
			    sprintf ( string , "%d=%d" , n , DISCARD_NUMBER );
			    HTParseFormInput(formfields, string );
			    printf ( "Message ID %d processed.\n" , n );
			}
		    }
		}
	    }
	}
    }

}

int clear_db( char *url , char *passwd )
{
    HTRequest * request = NULL;
    HTAnchor * anchor = NULL;   
    char* uri = NULL;
    char string[100];

    last_number = 0;

    memset ( string , 0 , sizeof ( string ));
    sprintf ( string , "adminpw=%s" , passwd );

    if ( !formfields )
	formfields = HTAssocList_new();

    /* Need our own trace and print functions */
    HTPrint_setCallback(printer);
    HTTrace_setCallback(tracer);

    
    HTParseFormInput(formfields, string );

    /* Create a new premptive client */
    HTProfile_newHTMLNoCacheClient ("MSIE", "5.5");

    /* Add our own filter to update the history list */
    HTNet_addAfter(terminate_handler, NULL, NULL, HT_ALL, HT_FILTER_LAST);

    /* Set the timeout for long we are going to wait for a response */
    HTHost_setEventTimeout(RESPONSE_WAIT);

    HText_registerElementCallback( GetNumber , NULL);    

    /* Create a request */
    request =  HTRequest_new();

    /* Get an anchor object for the URI */
    anchor = HTAnchor_findAddress(url);
    
    HTPostFormAnchor( formfields , anchor , request );

    /* Clean up the form fields */
    HTAssocList_delete(formfields);
    formfields = HTAssocList_new();

    /* Go into the event loop... */
    HTEventList_loop(request);

    return last_number;
}

void usage ( void )
{
    printf (
	" usage: qclear [OPTIONS]\n"
	" Process mailman administrative requests.\n"
	" -v , --verbose Set verbose mode\n"
	" -u , --url Set mailman administrative requests page url\n"
	" -p , --passwd Set mailman admin password\n"
	" -h , --help Show this usage\n");
}

int main ( int argc , char *argv[] )
{
    char url[URL_MAX];
    char passwd[PASSWD_MAX];
    int ret = 0;
    int opt = 0;
    
    memset ( url , 0 , URL_MAX );
    memset ( passwd , 0 , PASSWD_MAX );
    
    while (1)
    {
	int opt_index = 0 ;
	static struct option long_options[] = {
	    {"verbose",0,0,'v'},
	    {"url" , 1 , 0 , 'u' } ,
	    {"passwd" , 1 , 0 , 'p' } ,
	    {"help" , 0 , 0 , 'h' },
	    { 0,0,0,0 }
	};
	opt = getopt_long ( argc , argv , "vu:p:h" , long_options , &opt_index );
	if ( opt == -1 ) break;

	switch (opt)
	{
	case 'v':
	    verbose_mode = TRUE;
	    break;
	case 'u':
	    if ( strlen ( optarg ) < URL_MAX )
		strncpy ( url , optarg , URL_MAX );
	    break;
	case 'p':
	    if ( strlen ( optarg ) < PASSWD_MAX )
		strncpy ( passwd , optarg , PASSWD_MAX );
	    break;
	case 'h':
	default:
	    usage();
	    exit(FALSE);
	}
    }

    if ( strlen ( url ) <= 0 || strlen ( passwd ) <= 0 )
    {
	usage();
	exit(FALSE);
    }

    do 
    {
	ret = clear_db ( url , passwd );
    } while ( ret != 0 );

    if ( formfields )
	HTAssocList_delete(formfields);

    exit (TRUE);
}



